/****************************************************************************

	LineCbBox Class
	Copyright (C) 2009 Andre Deperrois adeperrois@xflr5.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

*****************************************************************************/


#ifndef LINECBBOX_H
#define LINECBBOX_H

#include <QComboBox>
#include <misc/linestyle.h>


class LineCbBox : public QComboBox
{

public:
	LineCbBox(QWidget *pParent=NULL);

	QSize sizeHint() const;
	void paintEvent (QPaintEvent *event);

	void setLine(int const &style, int const &width, QColor const &color, const int &pointStyle);
	void setLine(LineStyle lineStyle);
	void showPoints(bool bShow){m_bShowPoints=bShow;}

	bool points() {return m_bShowPoints; }

private:
	LineStyle m_LineStyle;
	bool m_bShowPoints;
};

#endif // LINECBBOX_H
